﻿Imports System
Imports System.Data
Imports System.Data.OleDb
Imports System.IO
Imports System.Text
Imports System.Windows.Forms
Imports System.Xml

Namespace SaveRowFilter
    Public Partial Class Form1
        Inherits Form
        Private _myMemoryStream As MemoryStream
        Private _myXmlTextWriter As XmlTextWriter
        Private _dt As DataTable
        Private _filterXmlDocument As XmlDocument


        Public Sub New()
            InitializeComponent()
        End Sub

        Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs)
            _dt = New DataTable()
            Dim connectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments), "ComponentOne Samples\Common\C1NWind.mdb") & ";"
            Dim conn As OleDbConnection = New OleDbConnection(connectionString)
            Dim adapter As OleDbDataAdapter = New OleDbDataAdapter("Select * from Data", conn)
            adapter.Fill(_dt)

            fpSpread1.DataSource = _dt
            fpSpread1.ActiveSheet.Columns(0, 5).AllowAutoFilter = True
            fpSpread1.ActiveSheet.AutoFilterMode = FarPoint.Win.Spread.AutoFilterMode.EnhancedContextMenu
        End Sub

        Private Sub saveBtn_Click(ByVal sender As Object, ByVal e As EventArgs)
            _myMemoryStream = New MemoryStream()
            _myXmlTextWriter = New XmlTextWriter(_myMemoryStream, Encoding.UTF8)
            _myXmlTextWriter.Formatting = Formatting.Indented
            _myXmlTextWriter.Indentation = 2
            _myXmlTextWriter.WriteStartDocument()
            _myXmlTextWriter.WriteStartElement("AppliedFilter")
            fpSpread1.ActiveSheet.RowFilter.Serialize(_myXmlTextWriter)
            _myXmlTextWriter.WriteEndElement()
            _myXmlTextWriter.WriteEndDocument()
            _myXmlTextWriter.Flush()

            If _myMemoryStream.Position > 0 Then
                _myMemoryStream.Position = 0
            End If

            _filterXmlDocument = New XmlDocument()
            _filterXmlDocument.Load(_myMemoryStream)
            _myXmlTextWriter.Close()


        End Sub

        Private Sub clearBtn_Click(ByVal sender As Object, ByVal e As EventArgs)
            fpSpread1.ActiveSheet.ClearRowFilter()
        End Sub

        Private Sub delRowBtn_Click(ByVal sender As Object, ByVal e As EventArgs)
            'fpSpread1.ActiveSheet.Rows.Count = 0;
            'fpSpread1.ActiveSheet.Rows.Clear();
        End Sub

        Private Sub loadFilterBtn_Click(ByVal sender As Object, ByVal e As EventArgs)
            fpSpread1.ActiveSheet.Columns(0, 5).AllowAutoFilter = True
            fpSpread1.ActiveSheet.AutoFilterMode = FarPoint.Win.Spread.AutoFilterMode.EnhancedContextMenu
            If _filterXmlDocument IsNot Nothing Then
                Dim node = _filterXmlDocument.FirstChild
                While node IsNot Nothing AndAlso Not node.Name.Equals("AppliedFilter")
                    node = node.NextSibling
                End While
                If node IsNot Nothing Then
                    Dim myXMLNodeReader As XmlNodeReader = New XmlNodeReader(node)
                    myXMLNodeReader.Read()
                    fpSpread1.ActiveSheet.RowFilter.Deserialize(myXMLNodeReader)
                End If
            End If
        End Sub
    End Class
End Namespace
